<!doctype html>
<html class="no-js" lang="">
    <head>
        <meta charset="utf-8">
        <meta http-equiv="x-ua-compatible" content="ie=edge">
        <title>frontend documentation</title>
        <meta name="description" content="">
        <meta name="viewport" content="width=device-width, initial-scale=1">

        <link rel="icon" type="image/x-icon" href="../images/favicon.ico">
	      <link rel="stylesheet" href="../styles/style.css">
    </head>
    <body>

        <div class="navbar navbar-default navbar-fixed-top visible-xs">
            <a href="../" class="navbar-brand">frontend documentation</a>
            <button type="button" class="btn btn-default btn-menu ion-ios-menu" id="btn-menu"></button>
        </div>

        <div class="xs-menu menu" id="mobile-menu">
                <div id="book-search-input" role="search"><input type="text" placeholder="Type to search"></div>            <compodoc-menu></compodoc-menu>
        </div>

        <div class="container-fluid main">
           <div class="row main">
               <div class="hidden-xs menu">
                   <compodoc-menu mode="normal"></compodoc-menu>
               </div>
               <!-- START CONTENT -->
               <div class="content class">
                   <div class="content-data">











<ol class="breadcrumb">
  <li>Classes</li>
  <li>DocumentsDataSource</li>
</ol>

<ul class="nav nav-tabs" role="tablist">
        <li class="active">
            <a href="#info" role="tab" id="info-tab" data-toggle="tab" data-link="info">Info</a>
        </li>
        <li >
            <a href="#source" role="tab" id="source-tab" data-toggle="tab" data-link="source">Source</a>
        </li>
</ul>

<div class="tab-content">
    <div class="tab-pane fade active in" id="c-info">
        <p class="comment">
            <h3>File</h3>
        </p>
        <p class="comment">
            <code>src/app/operation/parameters/document/document-edit.component.ts</code>
        </p>


            <p class="comment">
                <h3>Extends</h3>
            </p>
            <p class="comment">
                    <code>DataSource</code>
            </p>



            <section>
    <h3 id="index">Index</h3>
    <table class="table table-sm table-bordered index-table">
        <tbody>
                <tr>
                    <td class="col-md-4">
                        <h6><b>Properties</b></h6>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <ul class="index-list">
                            <li>
                                    <span class="modifier">Private</span>
                                <a href="#documents">documents</a>
                            </li>
                        </ul>
                    </td>
                </tr>

                <tr>
                    <td class="col-md-4">
                        <h6><b>Methods</b></h6>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <ul class="index-list">
                            <li>
                                <a href="#connect">connect</a>
                            </li>
                            <li>
                                <a href="#disconnect">disconnect</a>
                            </li>
                            <li>
                                    <span class="modifier">Private</span>
                                <a href="#translate">translate</a>
                            </li>
                        </ul>
                    </td>
                </tr>





        </tbody>
    </table>
</section>

            <section>
    <h3 id="constructor">Constructor</h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
<code>constructor(parametersModel: <a href="../injectables/OperationParametersModel.html">OperationParametersModel</a>, sort: MatSort, translateService: TranslateService)</code>
                    </td>
                </tr>
                        <tr>
                            <td class="col-md-4">
                                <div class="io-line">Defined in <a href="" data-line="242" class="link-to-prism">src/app/operation/parameters/document/document-edit.component.ts:242</a></div>
                            </td>
                        </tr>

                <tr>
                    <td class="col-md-4">
                            <div>
                                    <b>Parameters :</b>
                                    <table class="params">
                                        <thead>
                                            <tr>
                                                <td>Name</td>
                                                    <td>Type</td>
                                                <td>Optional</td>
                                            </tr>
                                        </thead>
                                        <tbody>
                                                <tr>
                                                        <td>parametersModel</td>
                                                  
                                                        <td>
                                                                    <code><a href="../injectables/OperationParametersModel.html" target="_self" >OperationParametersModel</a></code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                                <tr>
                                                        <td>sort</td>
                                                  
                                                        <td>
                                                                    <code>MatSort</code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                                <tr>
                                                        <td>translateService</td>
                                                  
                                                        <td>
                                                                    <code>TranslateService</code>
                                                        </td>
                                                  
                                                    <td>
                                                            No
                                                    </td>
                                                    
                                                </tr>
                                        </tbody>
                                    </table>
                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
</section>

            <section>
    
        <h3 id="inputs">
            Properties
        </h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="documents"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Private</span>
                            documents
                            </b>
                            <a href="#documents"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                        <span class="modifier-icon icon ion-ios-reset"></span><code>documents:     <code><a href="../classes/OperationFile.html" target="_self" >OperationFile[]</a></code>
</code>
                    </td>
                </tr>
                    <tr>
                        <td class="col-md-4">
                            <i>Type : </i>    <code><a href="../classes/OperationFile.html" target="_self" >OperationFile[]</a></code>

                        </td>
                    </tr>
                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="242" class="link-to-prism">src/app/operation/parameters/document/document-edit.component.ts:242</a></div>
                            </td>
                        </tr>


            </tbody>
        </table>
</section>

            <section>
    
        <h3 id="methods">
            Methods
        </h3>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="connect"></a>
                        <span class="name">
                            <b>
                            connect
                            </b>
                            <a href="#connect"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
<code>connect()</code>
                    </td>
                </tr>


                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="251" class="link-to-prism">src/app/operation/parameters/document/document-edit.component.ts:251</a></div>
                            </td>
                        </tr>


                <tr>
                    <td class="col-md-4">

                            <div class="io-description">
                                <b>Returns : </b>    <code><a href="../classes/OperationFile.html" target="_self" >Observable&lt;OperationFile[]&gt;</a></code>

                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="disconnect"></a>
                        <span class="name">
                            <b>
                            disconnect
                            </b>
                            <a href="#disconnect"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
<code>disconnect()</code>
                    </td>
                </tr>


                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="259" class="link-to-prism">src/app/operation/parameters/document/document-edit.component.ts:259</a></div>
                            </td>
                        </tr>


                <tr>
                    <td class="col-md-4">

                            <div class="io-description">
                                <b>Returns : </b>    <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >void</a></code>

                            </div>
                    </td>
                </tr>
            </tbody>
        </table>
        <table class="table table-sm table-bordered">
            <tbody>
                <tr>
                    <td class="col-md-4">
                        <a name="translate"></a>
                        <span class="name">
                            <b>
                                <span class="modifier">Private</span>
                            translate
                            </b>
                            <a href="#translate"><span class="icon ion-ios-link"></span></a>
                        </span>
                    </td>
                </tr>
                <tr>
                    <td class="col-md-4">
                            <span class="modifier-icon icon ion-ios-reset"></span>
                        <code>translate(documents: <a href="../classes/OperationFile.html">OperationFile[]</a>)</code>
                    </td>
                </tr>


                        <tr>
                            <td class="col-md-4">
                                    <div class="io-line">Defined in <a href="" data-line="262" class="link-to-prism">src/app/operation/parameters/document/document-edit.component.ts:262</a></div>
                            </td>
                        </tr>


                <tr>
                    <td class="col-md-4">

                            <div class="io-description">
                                    <b>Parameters :</b>
                                    <table class="params">
                                        <thead>
                                            <tr>
                                                <td>Name</td>
                                                    <td>Type</td>
                                                <td>Optional</td>
                                            </tr>
                                        </thead>
                                        <tbody>
                                                <tr>
                                                        <td>documents</td>
                                                        <td>
                                                                    <code><a href="../classes/OperationFile.html" target="_self" >OperationFile[]</a></code>
                                                        </td>
                                                    
                                                    <td>
                                                            No
                                                    </td>
                                                    

                                                </tr>
                                        </tbody>
                                    </table>
                            </div>
                            <div>
                            </div>
                            <div class="io-description">
                                <b>Returns : </b>    <code><a href="https://www.typescriptlang.org/docs/handbook/basic-types.html" target="_blank" >any</a></code>

                            </div>
                                <div class="io-description">
                                    
                                </div>
                    </td>
                </tr>
            </tbody>
        </table>
</section>






    </div>


    <div class="tab-pane fade  tab-source-code" id="c-source">
        <pre class="line-numbers compodoc-sourcecode"><code class="language-typescript">import { Component, OnInit, ViewChild } from &quot;@angular/core&quot;;
import { FormBuilder, FormGroup, Validators } from &quot;@angular/forms&quot;;
import { OperationParametersModel } from &quot;../model/operation-parameters.model&quot;;
import { OperationFile } from &quot;../../../core/model/operation-file&quot;;
import { Operation } from &quot;../../model/operation&quot;;
import { DocumentService } from &quot;./service/document.service&quot;;
import { Observable } from &quot;rxjs/Observable&quot;;
import { DataSource } from &quot;@angular/cdk/collections&quot;;
import { MatSnackBar, MatSort, MatSortable } from &quot;@angular/material&quot;;
import { sortOnProperty } from &quot;../../../core/util/table-utils&quot;;
import { TranslateService } from &quot;@ngx-translate/core&quot;;
import { TdDialogService } from &quot;@covalent/core&quot;;
import * as _ from &quot;underscore&quot;;
import { FileService } from &quot;app/core/service/file-service/file-service&quot;;
import { map } from &quot;rxjs/operators&quot;;
import { merge } from &quot;rxjs/observable/merge&quot;;
import { AuthorizationService } from &quot;../../../core/service/http/authorization.service&quot;;
import { ConfirmBeforeQuit } from &quot;../../../core/confirm-before-quit&quot;;
import { UploadInputComponent } from &quot;../../../shared/upload-input/upload-input.component&quot;;
import { Subscription } from &quot;rxjs/Subscription&quot;;
import { ReadOnlyService } from &quot;../../service/read-only.service&quot;;
import { HighlightedQuestionListComponent } from &quot;./highlighted-question/components/highlighted-question-list.component&quot;;
import { isFormModifiedAndNotSaved } from &#x27;../../../core/util/form-utils&#x27;;

const ALL_TYPES &#x3D; [
  {value: &#x27;DOCUMENT_FAQ&#x27;, labelKey: &#x27;parameters.document.edit.form.fields.type.label-key.DOCUMENT_FAQ&#x27;},
  {value: &#x27;DOCUMENT_TERMS&#x27;, labelKey: &#x27;parameters.document.edit.form.fields.type.label-key.DOCUMENT_TERMS&#x27;},
  {value: &#x27;DOCUMENT_CERTIFICATE&#x27;, labelKey: &#x27;parameters.document.edit.form.fields.type.label-key.DOCUMENT_CERTIFICATE&#x27;}
];

const ALL_LANGUAGES &#x3D; [
  {value: &#x27;DE&#x27;, labelKey: &#x27;parameters.document.edit.form.fields.language.label-key.DE&#x27;},
  {value: &#x27;FR&#x27;, labelKey: &#x27;parameters.document.edit.form.fields.language.label-key.FR&#x27;},
  {value: &#x27;IT&#x27;, labelKey: &#x27;parameters.document.edit.form.fields.language.label-key.IT&#x27;},
  {value: &#x27;RM&#x27;, labelKey: &#x27;parameters.document.edit.form.fields.language.label-key.RM&#x27;}
];

@Component({
  templateUrl: &#x27;./document-edit.component.html&#x27;,
  styleUrls: [&#x27;../parameter-edit.scss&#x27;, &#x27;./document-edit.component.scss&#x27;]
})
export class DocumentEditComponent implements OnInit, ConfirmBeforeQuit {
  operation: Operation;
  documents: OperationFile[];
  @ViewChild(MatSort) sort: MatSort;
  @ViewChild(UploadInputComponent) uploadInputComponent: UploadInputComponent;
  @ViewChild(HighlightedQuestionListComponent) questionListComponent: HighlightedQuestionListComponent;
  documentTypes &#x3D; ALL_TYPES;
  languages &#x3D; ALL_LANGUAGES;
  documentForm: FormGroup;
  documentsDataSource: DocumentsDataSource;
  private _subscriptions: Subscription[] &#x3D; [];
  private _readOnly &#x3D; false;

  constructor(private formBuilder: FormBuilder,
              private parametersModel: OperationParametersModel,
              private documentService: DocumentService,
              private dialogService: TdDialogService,
              private translateService: TranslateService,
              private fileService: FileService,
              private authorizationService: AuthorizationService,
              private readOnlyService: ReadOnlyService,
              private snackBar: MatSnackBar) {
    this.createForm();
    this.documentForm.reset({documentType: null, documentLanguage: null});
  }

  ngOnInit() {

    this._subscriptions.push(
      this.readOnlyService.isDocumentInReadOnly()
        .subscribe(
          readOnly &#x3D;&gt; {
            this._readOnly &#x3D; readOnly;
          }
        ),
      this.parametersModel.currentOperation.subscribe(operation &#x3D;&gt; this.operation &#x3D; operation),
      this.parametersModel.currentDocumentFiles.subscribe(documents &#x3D;&gt; this.documents &#x3D; documents));

    this.documentsDataSource &#x3D; new DocumentsDataSource(this.parametersModel, this.sort, this.translateService);
    this.updateTypes();
    this.updateLanguages();

    //The first sort is done on ballotId column
    // To conform to the SFD, the second column to be sorted is language but matsort doesn&#x27;t support this feature yet.
    // An issue is opened for this purpose
    // TODO : https://github.com/angular/material2/issues/7226
    this.sort.sort(&lt;MatSortable&gt;{
        id: &quot;type&quot;,
        start: &quot;asc&quot;,
      }
    );
  }


  get readOnly(): boolean {
    return this._readOnly;
  }


  get allDocumentsAreImported() {
    return this.documents &amp;&amp; this.documents.length &#x3D;&#x3D; ALL_TYPES.length * ALL_LANGUAGES.length;
  }

  get documentsDisplayedColumns() {
    let readableColumn &#x3D; [&#x27;type&#x27;, &#x27;language&#x27;, &#x27;file&#x27;];
    if (!this.readOnly &amp;&amp; this.authorizationService.hasAtLeastOneRole([&#x27;DELETE_OPERATION_DOCUMENTATION&#x27;])) {
      return readableColumn.concat([&#x27;delete&#x27;]);
    }
    return readableColumn;
  }

  get uploadUrl(): string {
    return &#x60;${this.documentService.serviceUrl}/${this.operation.id}/upload/${this.documentForm.value.documentType}/${this.documentForm.value.documentLanguage}&#x60;;
  }

  isFormModified(): boolean {
    return this.questionListComponent.inEdition ||
           this.uploadInputComponent &amp;&amp;
           (this.uploadInputComponent.isFormModified() ||
           isFormModifiedAndNotSaved(this.documentForm, false));
  }



  ngOnDestroy(): void {
    this._subscriptions.forEach(s &#x3D;&gt; s.unsubscribe());
  }

  checkBeforeUpload() {
    return () &#x3D;&gt; {
      this.documentForm.controls.documentType.markAsTouched();
      this.documentForm.controls.documentLanguage.markAsTouched();
      this.documentForm.updateValueAndValidity();
      return this.documentForm.valid;
    }
  }

  processUploadResult(document: OperationFile) {
    if (document) {
      let existingDocument &#x3D; _.find(this.documents, doc &#x3D;&gt; {
        return doc.businessKey &#x3D;&#x3D;&#x3D; document.businessKey;
      });
      if (existingDocument) {
        this.removeDocument(existingDocument.id);
      }
      this.documents.push(document);
      this.parametersModel.updateDocumentFiles(this.documents);
      // UI-feedback: notify user that import was successful
      this.snackBar.open(
        this.translateService.instant(
          &#x27;parameters.document.edit.form.import-success&#x27;,
          {fileName: document.fileName}
        ),
        &#x27;&#x27;,
        {
          duration: 5000
        }
      );
      this.documentForm.reset({documentType: null, documentLanguage: null});
      this.updateTypes();
      this.updateLanguages();
    }
  }

  download(e, document: OperationFile) {
    this.documentService.download(document.id).subscribe(blob &#x3D;&gt; {
      this.fileService.downloadBlob(document.fileName, blob)
    });
    e.preventDefault();
  }

  deleteFile(document: OperationFile) {
    this.dialogService.openConfirm({
      message: this.translateService.instant(&#x27;parameters.document.edit.delete-dialog.message&#x27;,
        {fileName: document.fileName}),
      disableClose: true,
      cancelButton: this.translateService.instant(&#x27;global.actions.no&#x27;),
      acceptButton: this.translateService.instant(&#x27;global.actions.yes&#x27;),
    }).afterClosed().subscribe((accept: boolean) &#x3D;&gt; {
      if (accept) {
        this.documentService.deleteFile(document.id).subscribe(() &#x3D;&gt; {
          this.snackBar.open(
            this.translateService.instant(
              &#x27;parameters.document.edit.delete-success&#x27;, {fileName: document.fileName}),
            &#x27;&#x27;,
            {duration: 5000}
          );
          this.removeDocument(document.id);
          this.parametersModel.updateDocumentFiles(this.documents);
          this.updateTypes();
          this.updateLanguages();
        });
      }
    });
  }

  private updateTypes() {
    let documentLanguage &#x3D; this.documentForm.controls.documentLanguage.value;
    if (documentLanguage) {
      let documentsByTypes &#x3D; this.documents.filter(document &#x3D;&gt; document.language &#x3D;&#x3D; documentLanguage)
        .map(document &#x3D;&gt; document.type);
      this.documentTypes &#x3D; ALL_TYPES.filter(type &#x3D;&gt; documentsByTypes.indexOf(type.value) &#x3D;&#x3D; -1);
    } else {
      this.documentTypes &#x3D; ALL_TYPES;
    }
  }

  private updateLanguages() {
    let documentType &#x3D; this.documentForm.controls.documentType.value;
    if (documentType) {
      let documentsByLanguages &#x3D; this.documents.filter(document &#x3D;&gt; document.type &#x3D;&#x3D; documentType)
        .map(document &#x3D;&gt; document.language);
      this.languages &#x3D; ALL_LANGUAGES.filter(language &#x3D;&gt; documentsByLanguages.indexOf(language.value) &#x3D;&#x3D; -1);
    } else {
      this.languages &#x3D; ALL_LANGUAGES;
    }
  }

  private removeDocument(documentId: number) {
    this.documents &#x3D; _.reject(this.documents, function (document: OperationFile) {
      return document.id &#x3D;&#x3D;&#x3D; documentId;
    });
  }

  private createForm() {
    this.documentForm &#x3D; this.formBuilder.group({
      documentType: [
        {value: null},
        Validators.required
      ],
      documentLanguage: [
        {value: null},
        Validators.required
      ]
    })
  }
}

class DocumentsDataSource extends DataSource&lt;OperationFile&gt; {

  private documents: OperationFile[];

  constructor(private parametersModel: OperationParametersModel,
              private sort: MatSort,
              private translateService: TranslateService) {
    super();
    this.parametersModel.currentDocumentFiles.subscribe(files &#x3D;&gt; this.documents &#x3D; files);
  }

  connect(): Observable&lt;OperationFile[]&gt; {
    return merge(this.parametersModel.currentDocumentFiles, this.sort.sortChange,
      this.translateService.onLangChange).pipe(
      map(() &#x3D;&gt; this.translate(this.documents)),
      map((documents) &#x3D;&gt; sortOnProperty(documents, this.sort.active, this.sort.direction))
    )
  }

  disconnect() {
  }

  private translate(documents: OperationFile[]) {
    return documents.map(document &#x3D;&gt; Object.assign(
      {},
      document,
      {
        language: this.translateService.instant(
          &#x60;parameters.document.edit.form.fields.language.label-key.${document.language}&#x60;),
        type: this.translateService.instant(
          &#x60;parameters.document.edit.form.fields.type.label-key.${document.type}&#x60;)
      }));
  }
}
</code></pre>
    </div>
</div>







                   </div><div class="search-results">
    <div class="has-results">
        <h1 class="search-results-title"><span class='search-results-count'></span> result-matching "<span class='search-query'></span>"</h1>
        <ul class="search-results-list"></ul>
    </div>
    <div class="no-results">
        <h1 class="search-results-title">No results matching "<span class='search-query'></span>"</h1>
    </div>
</div>
</div>
               <!-- END CONTENT -->
           </div>
       </div>

       <script>
            var COMPODOC_CURRENT_PAGE_DEPTH = 1;
            var COMPODOC_CURRENT_PAGE_CONTEXT = 'class';
            var COMPODOC_CURRENT_PAGE_URL = 'DocumentsDataSource.html';
       </script>

       <script src="../js/libs/custom-elements.min.js"></script>
       <script src="../js/libs/lit-html.js"></script>
       <!-- Required to polyfill modern browsers as code is ES5 for IE... -->
       <script src="../js/libs/custom-elements-es5-adapter.js" charset="utf-8" defer></script>
       <script src="../js/menu-wc.js" defer></script>

       <script src="../js/libs/bootstrap-native.js"></script>

       <script src="../js/libs/es6-shim.min.js"></script>
       <script src="../js/libs/EventDispatcher.js"></script>
       <script src="../js/libs/promise.min.js"></script>
       <script src="../js/libs/zepto.min.js"></script>

       <script src="../js/compodoc.js"></script>

       <script src="../js/tabs.js"></script>
       <script src="../js/menu.js"></script>
       <script src="../js/libs/clipboard.min.js"></script>
       <script src="../js/libs/prism.js"></script>
       <script src="../js/sourceCode.js"></script>
          <script src="../js/search/search.js"></script>
          <script src="../js/search/lunr.min.js"></script>
          <script src="../js/search/search-lunr.js"></script>
          <script src="../js/search/search_index.js"></script>
       <script src="../js/lazy-load-graphs.js"></script>


    </body>
</html>
